Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
- Adaptations
- Analyzer
- AnalyzerPlugins
- Checkable
- ConstantFolder
- ContextErrors
- ContextMode
- Contexts
- DestructureTypes
- Duplicators
- EtaExpansion
- Fingerprint
- Implicits
- ImplicitsStats
- Infer
- Macros
- MacrosStats
- MethodSynthesis
- Namers
- NamesDefaults
- PatternTypers
- RefChecks
- StdAttachments
- StructuredTypeStrings
- SuperAccessors
- SyntheticMethods
- Tags
- TreeCheckers
- TypeDiagnostics
- TypeStrings
- Typers
- TypersStats
- TypersTracking
- Unapplies

t

scala.tools.nsc.typechecker

# Namers 

###

#### trait Namers extends MethodSynthesis

This trait declares methods to create symbols and to enter them into scopes.

Self Type
  Analyzer
Source
  Namers.scala
Version

  1.0

Linear Supertypes
MethodSynthesis, AnyRef, Any
Known Subclasses
erasure, treeChecker, ScaladocAnalyzer, InteractiveAnalyzer, Erasure, Duplicator, SpecializationDuplicator, Analyzer, Duplicators, TreeCheckers
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Namers
2. MethodSynthesis
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  class ClassMethodSynthesis extends AnyRef
   Definition Classes
     MethodSynthesis
2.  trait MethodSynth extends AnyRef

   There are two key methods in here.

   There are two key methods in here.

   1) Enter methods such as enterGetterSetter are called from Namer with a tree which may generate further trees such as accessors or implicit wrappers. Some setup is performed. In general this creates symbols and enters them into the scope of the owner.

   2) addDerivedTrees is called from Typer when a Template is typed. It completes the job, returning a list of trees with their symbols set to those created in the enter methods. Those trees then become part of the typed template.

   Definition Classes
     MethodSynthesis
3.  class CompleterWrapper extends Analyzer.TypeCompleter

   Wrap an existing completer to do some post/pre-processing of the completed type.

4.  trait LockingTypeCompleter extends Analyzer.TypeCompleter
5.  abstract class Namer extends Analyzer.MethodSynth with Analyzer.NamerContextErrors
6.  class PolyTypeCompleter extends Analyzer.TypeCompleter with Analyzer.LockingTypeCompleter with Global.FlagAgnosticCompleter

   A class representing a lazy type with known type parameters.

   A class representing a lazy type with known type parameters. `ctx` is the namer context in which the `owner` is defined.

   Constructing a PolyTypeCompleter for a DefDef creates type skolems for the type parameters and assigns them to the `tparams` trees.

7.  abstract class TypeCompleter extends Global.LazyType
8.  abstract class TypeCompleterBase [T <: Global.Tree] extends Analyzer.TypeCompleter with Analyzer.LockingTypeCompleter with Global.FlagAgnosticCompleter

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Namers to any2stringadd[Namers] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Namers, B)
   Implicit
     This member is added by an implicit conversion from Namers to ArrowAssoc[Namers] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  val _lockedCount: Int
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
9.  def companionSymbolOf(original: Global.Symbol, ctx: Analyzer.Context): Global.Symbol

   The companion class or companion module of `original`.

   The companion class or companion module of `original`. Calling .companionModule does not work for classes defined inside methods.

   !!! Then why don't we fix companionModule? Does the presence of these methods imply all the places in the compiler calling sym.companionModule are bugs waiting to be reported? If not, why not? When exactly do we need to call this method?

10.  def ensuring(cond: (Namers) ⇒ Boolean, msg: ⇒ Any): Namers
    Implicit
      This member is added by an implicit conversion from Namers to Ensuring[Namers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: (Namers) ⇒ Boolean): Namers
    Implicit
      This member is added by an implicit conversion from Namers to Ensuring[Namers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean, msg: ⇒ Any): Namers
    Implicit
      This member is added by an implicit conversion from Namers to Ensuring[Namers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean): Namers
    Implicit
      This member is added by an implicit conversion from Namers to Ensuring[Namers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
15.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
16.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
17.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Namers to StringFormat[Namers] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
18.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
19.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
20.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
21.  final def linkedClassOfClassOf(original: Global.Symbol, ctx: Analyzer.Context): Global.Symbol

    A version of `Symbol#linkedClassOfClass` that works with local companions, ala `companionSymbolOf`.

22.  def lockedCount: Int
23.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
24.  def newNamer(context: Analyzer.Context): Analyzer.Namer
25.  final def notify(): Unit
    Definition Classes
      AnyRef
26.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
27.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
28.  def toString(): String
    Definition Classes
      AnyRef → Any
29.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
30.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  def →[B](y: B): (Namers, B)
    Implicit
      This member is added by an implicit conversion from Namers to ArrowAssoc[Namers] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1.  def mkTypeCompleter(t: Global.Tree)(c: (Global.Symbol) ⇒ Unit): Analyzer.TypeCompleterBase[Global.Tree]
   Annotations
     @deprecated
   Deprecated

     (Since version 2.12.2) Instantiate TypeCompleterBase (for monomorphic, non-wrapping completer) or CompleterWrapper directly.

### Inherited from MethodSynthesis

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Namers to any2stringadd[Namers]

### Inherited by implicit conversion StringFormat from Namers to StringFormat[Namers]

### Inherited by implicit conversion Ensuring from Namers to Ensuring[Namers]

### Inherited by implicit conversion ArrowAssoc from Namers to ArrowAssoc[Namers]

### Ungrouped